jQuery(document).ready(function($) {

  var wc_billingo_plus_settings = {
    settings_groups: ['coupon', 'vatnumber', 'emails'],
    init: function() {
      this.init_toggle_groups();
      this.index_rounding_fields();

      $('.wc-billingo-plus-rounding-table').on('click', '.wc-billingo-plus-rounding-table-add', this.rounding_add);
      $('.wc-billingo-plus-rounding-table').on('click', '.wc-billingo-plus-rounding-table-remove', this.rounding_remove);
      $('#woocommerce_wc_billingo_pro_email').keypress(this.submit_pro_on_enter);
      $('#woocommerce_wc_billingo_plus_pro_key-submit').on('click', this.submit_activate_form);
      $('#woocommerce_wc_billingo_plus_pro_key-deactivate').on('click', this.submit_deactivate_form);

      if($('#woocommerce_wc_billingo_plus_block_uid').length) {
        $('#woocommerce_wc_billingo_plus_block_uid').parent().find('p.description').before('<a href="#" id="woocommerce_wc_billingo_plus_block_uid_reload"><span class="dashicons dashicons-update"></span></a>');
        $('#woocommerce_wc_billingo_plus_block_uid').parent().on('click', '#woocommerce_wc_billingo_plus_block_uid_reload', this.refresh_invoice_blocks);
      }
    },
    init_toggle_groups: function() {
      $.each(wc_billingo_plus_settings.settings_groups, function( index, value ) {
        var checkbox = $('.wc-billingo-plus-toggle-group-'+value);
        var group_items = $('.wc-billingo-plus-toggle-group-'+value+'-item').parents('tr');
        var checked = checkbox.is(":checked");

        if(value == 'emails' && $('.wc-billingo-plus-toggle-group-'+value+':checked').length) {
          checked = true;
        }

        if(checked) {
          group_items.show();
        } else {
          group_items.hide();
        }
        checkbox.change(function(e){
          e.preventDefault();

          var checked = $(this).is(":checked");
          if(value == 'emails' && $('.wc-billingo-plus-toggle-group-'+value+':checked').length) {
            checked = true;
          }

          if(checked) {
            group_items.show();
          } else {
            group_items.hide();
          }
        });
      });
    },
    rounding_add: function() {
      var table = $(this).closest('tbody');
      var row = $(this).closest('tr');
      table.append(row.clone());
      wc_billingo_plus_settings.index_rounding_fields();
      return false;
    },
    rounding_remove: function() {
      var row = $(this).closest('tr');
      row.remove();
      wc_billingo_plus_settings.index_rounding_fields();
      return false;
    },
    index_rounding_fields: function() {
      $('.wc-billingo-plus-rounding-table tbody tr').each(function(index, row){
        $(this).find('.wc-billingo-plus-rounding-table-currency select').attr('name', 'wc_billingo_plus_rounding_options['+index+'][currency]');
        $(this).find('.wc-billingo-plus-rounding-table-rounding select').attr('name', 'wc_billingo_plus_rounding_options['+index+'][rounding]');
      });
    },
    submit_pro_on_enter: function(e) {
      if (e.which == 13) {
        $(this).parent().find('button').click();
        return false;
      }
    },
    submit_activate_form: function() {
      var key = $('#woocommerce_wc_billingo_pro_key').val();
      var email = $('#woocommerce_wc_billingo_pro_email').val();
      var button = $(this);
      var form = button.parents('.wc-billingo-plus-section-pro');

      var data = {
        action: 'wc_billingo_pro_check',
        key: key,
        email: email
      };

      form.block({
        message: null,
        overlayCSS: {
          background: '#ffffff url(' + wc_billingo_plus_params.loading + ') no-repeat center',
          backgroundSize: '16px 16px',
          opacity: 0.6
        }
      });

      form.find('.notice').hide();

      $.post(ajaxurl, data, function(response) {
        //Remove old messages
        if(response.success) {
          window.location.reload();
          return;
        } else {
          form.find('.notice p').html(response.data.message);
          form.find('.notice').show();
        }
        form.unblock();
      });

      return false;
    },
    submit_deactivate_form: function() {
      var button = $(this);
      var form = button.parents('.wc-billingo-plus-section-pro');

      var data = {
        action: 'wc_billingo_pro_deactivate'
      };

      form.block({
        message: null,
        overlayCSS: {
          background: '#ffffff url(' + wc_billingo_plus_params.loading + ') no-repeat center',
          backgroundSize: '16px 16px',
          opacity: 0.6
        }
      });

      form.find('.notice').hide();

      $.post(ajaxurl, data, function(response) {
        //Remove old messages
        if(response.success) {
          window.location.reload();
          return;
        } else {
          form.find('.notice p').html(response.data.message);
          form.find('.notice').show();
        }
        form.unblock();
      });
      return false;
    },
    refresh_invoice_blocks: function() {
      var $this = $(this);
      var data = {
        action: 'wc_billingo_plus_reload_blocks'
      };

      if(!$this.hasClass('loading')) {
        $this.addClass('loading');
        $.post(ajaxurl, data, function(response) {
          $this.removeClass('loading');
          $this.addClass('loaded');
          setTimeout(function() {
            $this.removeClass('loaded');
          }, 1000);
          if(response.data) {
            var $select = $('#woocommerce_wc_billingo_plus_block_uid');
            var currentOption = $select.val();
            $select.val(null).empty();
            response.data.forEach(function(block){
              var newOption = new Option(block.name, block.id, true, true);
              $select.append(newOption).trigger('change');
            });
            $select.val(currentOption);
            $select.trigger('change');
          }
        });
      }

      return false;
    }
  }

  // Hide notice
  $( '.wc-billingo-plus-notice .wc-billingo-plus-hide-notice').on('click', function(e) {
    e.preventDefault();
    var el = $(this).closest('.wc-billingo-plus-notice');
    $(el).find('.wc-billingo-plus-wait').remove();
    $(el).append('<div class="wc-billingo-plus-wait"></div>');
    if ( $('.wc-billingo-plus-notice.updating').length > 0 ) {
      var button = $(this);
      setTimeout(function(){
        button.triggerHandler( 'click' );
      }, 100);
      return false;
    }
    $(el).addClass('updating');
    $.post( ajaxurl, {
        action: 'wc_billingo_plus_hide_notice',
        security: $(this).data('nonce'),
        notice: $(this).data('notice'),
        remind: $(this).hasClass( 'remind-later' ) ? 'yes' : 'no'
    }, function(){
      $(el).removeClass('updating');
      $(el).fadeOut(100);
    });
  });

  $( '.wc-billingo-plus-notice .wc-billingo-plus-migrate-button').on('click', function(e) {
    e.preventDefault();
    var $this = $(this);
    var $el = $(this).closest('.wc-billingo-plus-notice');
    $el.find('.wc-billingo-plus-wait').remove();
    $el.append('<div class="wc-billingo-plus-wait"></div>');
    $el.addClass('updating');
    $.post( ajaxurl, {
      action: 'wc_billingo_plus_migrate',
      security: $(this).data('nonce')
    }, function(){
      window.location.href = $this.attr('href');
    });
  });

  //Metabox functions
  var wc_billingo_plus_metabox = {
    prefix: 'wc_billingo_plus_',
    prefix_id: '#wc_billingo_plus_',
    prefix_class: '.wc-billingo-plus-',
    $metaboxContent: $('#wc_billingo_plus_metabox .inside'),
    $disabledState: $('.wc-billingo-plus-metabox-disabled'),
    $optionsContent: $('.wc-billingo-plus-metabox-generate-options'),
    $autoMsg: $('.wc-billingo-plus-metabox-auto-msg'),
    $generateContent: $('.wc-billingo-plus-metabox-generate'),
    $optionsButton: $('#wc_billingo_plus_invoice_options'),
    $generateButton: $('#wc_billingo_plus_invoice_generate'),
    $invoiceRow: $('.wc-billingo-plus-metabox-invoices-invoice'),
    $proformRow: $('.wc-billingo-plus-metabox-invoices-proform'),
    $voidedRow: $('.wc-billingo-plus-metabox-invoices-void'),
    $completeRow: $('.wc-billingo-plus-metabox-rows-data-complete'),
    $emailRow: $('.wc-billingo-plus-metabox-rows-data-email'),
    $voidRow: $('.wc-billingo-plus-metabox-rows-data-void'),
    $messages: $('.wc-billingo-plus-metabox-messages'),
    nonce: $('.wc-billingo-plus-metabox-content').data('nonce'),
    order: $('.wc-billingo-plus-metabox-content').data('order'),
    init: function() {
      this.$optionsButton.on( 'click', this.show_options );
      $(this.prefix_class+'invoice-toggle').on( 'click', this.toggle_invoice );

      this.$generateButton.on( 'click', this.generate_invoice );
      this.$completeRow.find('a').on( 'click', this.mark_completed );
      this.$emailRow.find('a').on( 'click', this.resend_email );
      this.$voidRow.find('a').on( 'click', this.void_invoice );

      this.$messages.find('a').on( 'click', this.hide_message );
    },
    loading_indicator: function(button, color) {
      wc_billingo_plus_metabox.hide_message();
      button.block({
        message: null,
        overlayCSS: {
          background: color+' url(' + wc_billingo_plus_params.loading + ') no-repeat center',
          backgroundSize: '16px 16px',
          opacity: 0.6
        }
      });
    },
    show_options: function() {
      wc_billingo_plus_metabox.$optionsContent.slideToggle();
    },
    toggle_invoice: function() {
      var note = '';

      //Ask for message
      if($(this).hasClass('off')) {
        note = prompt("Számlakészítés kikapcsolása. Mi az indok?", "Ehhez a rendeléshez nem kell számla.");
        if (!note) {
          return false;
        }
      }

      //Create request
      var data = {
        action: wc_billingo_plus_metabox.prefix+'toggle_invoice',
        nonce: wc_billingo_plus_metabox.nonce,
        order: wc_billingo_plus_metabox.order,
        note: note
      };

      //Show loading indicator
      wc_billingo_plus_metabox.loading_indicator(wc_billingo_plus_metabox.$metaboxContent, '#fff');

      //Make request
      $.post(ajaxurl, data, function(response) {

        //Replace text
        wc_billingo_plus_metabox.$disabledState.find('span').text(note);

        //Hide loading indicator
        wc_billingo_plus_metabox.$metaboxContent.unblock();

        //Show/hide divs based on response
        if (response.data.state == 'off') {
          wc_billingo_plus_metabox.$disabledState.slideDown();
          wc_billingo_plus_metabox.$optionsContent.slideUp();
          wc_billingo_plus_metabox.$autoMsg.slideUp();
          wc_billingo_plus_metabox.$generateContent.slideUp();
          wc_billingo_plus_metabox.$voidedRow.slideUp();
        } else {
          wc_billingo_plus_metabox.$disabledState.slideUp();
          wc_billingo_plus_metabox.$autoMsg.slideDown();
          wc_billingo_plus_metabox.$generateContent.slideDown();
        }
      });

      return false;
    },
    generate_invoice: function() {
      var $this = $(this);
      var r = confirm($this.data('question'));
      var type = 'invoice';
      if (r != true) {
        return false;
      }

      var note = $('#wc_billingo_plus_invoice_note').val();
      var deadline = $('#wc_billingo_plus_invoice_deadline').val();
      var completed = $('#wc_billingo_plus_invoice_completed').val();
      var proform = $('#wc_billingo_plus_invoice_proform').is(':checked');
      if (proform) {
        type = 'proform';
      }

      //Create request
      var data = {
        action: wc_billingo_plus_metabox.prefix+'generate_invoice',
        nonce: wc_billingo_plus_metabox.nonce,
        order: wc_billingo_plus_metabox.order,
        note: note,
        deadline: deadline,
        completed: completed,
        type: type
      };

      //Show loading indicator
      wc_billingo_plus_metabox.loading_indicator(wc_billingo_plus_metabox.$metaboxContent, '#fff');

      //Make request
      $.post(ajaxurl, data, function(response) {

        //Hide loading indicator
        wc_billingo_plus_metabox.$metaboxContent.unblock();

        //Show success/error messages
        wc_billingo_plus_metabox.show_messages(response);

        //On success and error
        if(response.data.error) {

        } else {

          if(response.data.type == 'invoice') {
            wc_billingo_plus_metabox.$autoMsg.slideUp();
            wc_billingo_plus_metabox.$generateContent.slideUp();
            wc_billingo_plus_metabox.$voidedRow.slideUp();

            wc_billingo_plus_metabox.$invoiceRow.find('strong').text(response.data.name);
            wc_billingo_plus_metabox.$invoiceRow.find('a').attr('href', response.data.link);
            wc_billingo_plus_metabox.$invoiceRow.slideDown();
            wc_billingo_plus_metabox.$completeRow.slideDown();
            wc_billingo_plus_metabox.$emailRow.slideDown();
            wc_billingo_plus_metabox.$voidRow.slideDown();
          }

          if(response.data.type == 'proform') {
            $('#wc_billingo_plus_invoice_normal').prop('checked', true);
            wc_billingo_plus_metabox.$optionsContent.slideUp();
            wc_billingo_plus_metabox.$proformRow.find('strong').text(response.data.name);
            wc_billingo_plus_metabox.$proformRow.find('a').attr('href', response.data.link);
            wc_billingo_plus_metabox.$proformRow.slideDown();
            wc_billingo_plus_metabox.$voidedRow.slideUp();
          }

        }

      });

      return false;
    },
    mark_completed_timeout: false,
    mark_completed: function() {
      var $this = $(this);

      //Do nothing if already marked completed
      if($this.hasClass('completed')) return false;

      if($this.hasClass('confirm')) {

        //Reset timeout
        clearTimeout(wc_billingo_plus_metabox.mark_completed_timeout);

        //Show loading indicator
        wc_billingo_plus_metabox.loading_indicator(wc_billingo_plus_metabox.$completeRow, '#fff');

        //Create request
        var data = {
          action: wc_billingo_plus_metabox.prefix+'mark_completed',
          nonce: wc_billingo_plus_metabox.nonce,
          order: wc_billingo_plus_metabox.order,
        };

        $.post(ajaxurl, data, function(response) {

          //Hide loading indicator
          wc_billingo_plus_metabox.$completeRow.unblock();

          //Show success/error messages
          wc_billingo_plus_metabox.show_messages(response);

          if(response.data.error) {
            //On success and error
            $this.fadeOut(function(){
              $this.text($this.data('trigger-value'));
              $this.removeClass('confirm');
              $this.fadeIn();
            });
          } else {
            //On success and error
            $this.fadeOut(function(){
              $this.text(response.data.completed);
              $this.addClass('completed');
              $this.fadeIn();
              $this.removeClass('confirm');
            });
          }

        });

      } else {
        wc_billingo_plus_metabox.mark_completed_timeout = setTimeout(function(){
          $this.fadeOut(function(){
            $this.text($this.data('trigger-value'));
            $this.fadeIn();
            $this.removeClass('confirm');
          });
        }, 5000);

        $this.addClass('confirm');
        $this.fadeOut(function(){
          $this.text('Biztos?')
          $this.fadeIn();
        });
      }

    },
    resend_email: function() {
      var $this = $(this);

      //Show loading indicator
      wc_billingo_plus_metabox.loading_indicator(wc_billingo_plus_metabox.$emailRow, '#fff');

      //Create request
      var data = {
        action: wc_billingo_plus_metabox.prefix+'resend_email',
        nonce: wc_billingo_plus_metabox.nonce,
        order: wc_billingo_plus_metabox.order,
      };

      $.post(ajaxurl, data, function(response) {

        //Hide loading indicator
        wc_billingo_plus_metabox.$emailRow.unblock();

        //Show success/error messages
        wc_billingo_plus_metabox.show_messages(response);

        //On success and error
        $this.fadeOut(function(){
          if(response.data.error) {
            $this.removeClass('completed');
            $this.text($this.data('trigger-value'));
            $this.fadeIn();
          } else {
            $this.text($this.data('done'));
            $this.addClass('completed');
            $this.fadeIn();
            setTimeout(function(){
              $this.fadeOut(function(){
                $this.removeClass('completed');
                $this.text($this.data('trigger-value'));
                $this.fadeIn();
              });
            }, 3000);
          }
        });

      });


    },
    void_invoice_timeout: false,
    void_invoice: function() {
      var $this = $(this);

      //Do nothing if already marked completed
      if($this.hasClass('confirm')) {

        //Reset timeout
        clearTimeout(wc_billingo_plus_metabox.void_invoice_timeout);

        //Show loading indicator
        wc_billingo_plus_metabox.loading_indicator(wc_billingo_plus_metabox.$voidRow, '#fff');

        //Create request
        var data = {
          action: wc_billingo_plus_metabox.prefix+'void_invoice',
          nonce: wc_billingo_plus_metabox.nonce,
          order: wc_billingo_plus_metabox.order,
        };

        $.post(ajaxurl, data, function(response) {

          //Hide loading indicator
          wc_billingo_plus_metabox.$voidRow.unblock();

          //Show success/error messages
          wc_billingo_plus_metabox.show_messages(response);

          //On success and error
          if(response.data.error) {

          } else {

            wc_billingo_plus_metabox.$invoiceRow.slideUp();
            wc_billingo_plus_metabox.$proformRow.slideUp();
            wc_billingo_plus_metabox.$completeRow.slideUp();
            wc_billingo_plus_metabox.$emailRow.slideUp();
            wc_billingo_plus_metabox.$voidRow.slideUp(function(){
              $this.text(response.data.completed);
              $this.removeClass('confirm');
            });


            wc_billingo_plus_metabox.$voidedRow.find('strong').text(response.data.name);
            wc_billingo_plus_metabox.$voidedRow.find('a').attr('href', response.data.link);
            wc_billingo_plus_metabox.$voidedRow.slideDown();

            wc_billingo_plus_metabox.$generateContent.slideDown();
            wc_billingo_plus_metabox.$autoMsg.slideDown();

          }

          //On success and error
          $this.fadeOut(function(){
            $this.text($this.data('trigger-value'));
            $this.fadeIn();
            $this.removeClass('confirm');
          });

        });

      } else {
        wc_billingo_plus_metabox.void_invoice_timeout = setTimeout(function(){
          $this.fadeOut(function(){
            $this.text($this.data('trigger-value'));
            $this.fadeIn();
            $this.removeClass('confirm');
          });
        }, 5000);

        $this.addClass('confirm');
        $this.fadeOut(function(){
          $this.text($this.data('question'))
          $this.fadeIn();
        });
      }

    },
    show_messages: function(response) {
      if(response.data.messages && response.data.messages.length > 0) {
        this.$messages.removeClass('wc-billingo-plus-metabox-messages-success');
        this.$messages.removeClass('wc-billingo-plus-metabox-messages-error');

        if(response.data.error) {
          this.$messages.addClass('wc-billingo-plus-metabox-messages-error');
        } else {
          this.$messages.addClass('wc-billingo-plus-metabox-messages-success');
        }

        $ul = this.$messages.find('ul');
        $ul.html('');

        $.each(response.data.messages, function(i, value) {
          var li = $('<li>')
          li.append(value);
          $ul.append(li);
        });
        this.$messages.slideDown();
      }
    },
    hide_message: function() {
      wc_billingo_plus_metabox.$messages.slideUp();
      return false;
    }
  }

  if($('#wc_billingo_plus_metabox').length) {
    wc_billingo_plus_metabox.init();
  }

  if($('#woocommerce_wc_billingo_plus_section_auth').length) {
    wc_billingo_plus_settings.init();
  }

});
