<?php if(!$this->get_option('public_key') || !$this->get_option('private_key')): ?>

  <a href="<?php echo admin_url( 'admin.php?page=wc-settings&tab=integration&section=wc_billingo_plus' ); ?>" class="wc-billingo-plus-metabox-settings">
    <span><?php esc_html_e('A számlakészítéshez meg kell adnod az API kulcsokat a beállításokban','wc-billingo-plus'); ?></span>
    <span class="dashicons dashicons-arrow-right-alt2"></span>
  </a>

<?php else: ?>

  <div class="wc-billingo-plus-metabox-content" data-order="<?php echo absint($post->ID); ?>" data-nonce="<?php echo wp_create_nonce( "wc_billingo_generate_invoice" ); ?>">
    <div class="wc-billingo-plus-metabox-messages wc-billingo-plus-metabox-messages-success" style="display:none;">
      <div class="wc-billingo-plus-metabox-messages-content">
        <ul></ul>
        <a href="#"><span class="dashicons dashicons-no-alt"></span></a>
      </div>
    </div>

    <div class="wc-billingo-plus-metabox-disabled <?php if($order->get_meta('_wc_billingo_plus_own')): ?>show<?php endif; ?>">
      <?php $note = $order->get_meta('_wc_billingo_plus_own'); ?>
      <p>
        <?php esc_html_e('A számlakészítés ennél a rendelésnél ki lett kapcsolva, mert:','wc-billingo-plus'); ?> <span><?php echo esc_html($note); ?></span>
      </p>
      <p>
        <a class="wc-billingo-plus-invoice-toggle on" href="#" data-nonce="<?php echo wp_create_nonce( "wc_billingo_toggle_invoice" ); ?>" data-order="<?php echo absint($post->ID); ?>">
          <?php esc_html_e('Visszakapcsolás','wc-billingo-plus'); ?>
        </a>
      </p>
    </div>

    <?php $has_invoice = $order->get_meta( '_wc_billingo_plus_invoice_id' ); ?>

    <ul class="wc-billingo-plus-metabox-rows">
      <li class="wc-billingo-plus-metabox-rows-invoice wc-billingo-plus-metabox-invoices-proform <?php if($order->get_meta('_wc_billingo_plus_proform_id')): ?>show<?php endif; ?>">
        <a target="_blank" href="<?php echo $this->generate_download_link($order, 'proform'); ?>">
          <span><?php esc_html_e('Díjbekérő','wc-billingo-plus'); ?></span>
          <strong><?php echo esc_html($order->get_meta('_wc_billingo_plus_proform_name')); ?></strong>
        </a>
      </li>
      <li class="wc-billingo-plus-metabox-rows-invoice wc-billingo-plus-metabox-invoices-invoice <?php if($has_invoice): ?>show<?php endif; ?>">
        <a target="_blank" href="<?php echo $this->generate_download_link($order); ?>">
          <span><?php esc_html_e('Számla','wc-billingo-plus'); ?></span>
          <strong><?php echo esc_html($order->get_meta('_wc_billingo_plus_invoice_name')); ?></strong>
        </a>
      </li>
      <li class="wc-billingo-plus-metabox-rows-invoice wc-billingo-plus-metabox-invoices-void <?php if($order->get_meta('_wc_billingo_plus_void_id')): ?>show<?php endif; ?>">
        <a target="_blank" href="<?php echo $this->generate_download_link($order, 'void'); ?>">
          <span><?php esc_html_e('Sztornó számla','wc-billingo-plus'); ?></span>
          <strong><?php echo esc_html($order->get_meta('_wc_billingo_plus_void_name')); ?></strong>
        </a>
      </li>
      <li class="wc-billingo-plus-metabox-rows-data wc-billingo-plus-metabox-rows-data-complete <?php if($has_invoice): ?>show<?php endif; ?>">
        <div class="wc-billingo-plus-metabox-rows-data-inside">
          <span><?php esc_html_e('Fizetve','wc-billingo-plus'); ?></span>
          <a href="#" data-trigger-value="<?php esc_attr_e('Fizetettnek jelölés','wc-billingo-plus'); ?>" <?php if($order->get_meta('_wc_billingo_plus_completed')): ?>class="completed"<?php endif; ?>>
            <?php if(!$order->get_meta('_wc_billingo_plus_completed')): ?>
              <?php esc_html_e('Fizetettnek jelölés','wc-billingo-plus'); ?>
            <?php else: ?>
              <?php if($order->get_meta('_wc_billingo_plus_completed') == 1): ?>
                <?php esc_html_e('Fizetve','wc-billingo-plus'); ?>
              <?php else: ?>
                <?php echo date('Y-m-d',$order->get_meta('_wc_billingo_plus_completed')); ?>
              <?php endif; ?>
            <?php endif; ?>
          </a>
        </div>
      </li>
      <li class="wc-billingo-plus-metabox-rows-data wc-billingo-plus-metabox-rows-data-email <?php if($has_invoice): ?>show<?php endif; ?>">
        <div class="wc-billingo-plus-metabox-rows-data-inside">
          <span><?php esc_html_e('Számlaértesítő','wc-billingo-plus'); ?></span>
          <a href="#" data-trigger-value="<?php esc_attr_e('Újraküldés','wc-billingo-plus'); ?>" data-done="<?php esc_attr_e('Újraküldve','wc-billingo-plus'); ?>"><?php esc_html_e('Újraküldés','wc-billingo-plus'); ?></a>
        </div>
      </li>
      <li class="wc-billingo-plus-metabox-rows-data wc-billingo-plus-metabox-rows-data-void plugins <?php if($has_invoice): ?>show<?php endif; ?>">
        <div class="wc-billingo-plus-metabox-rows-data-inside">
          <a href="#" data-trigger-value="<?php esc_attr_e('Sztornózás','wc-billingo-plus'); ?>" data-question="<?php esc_attr_e('Biztosan sztornózod?','wc-billingo-plus'); ?>" class="delete"><?php esc_html_e('Sztornózás','wc-billingo-plus'); ?></a>
        </div>
      </li>
    </ul>

    <?php if($this->get_option('auto_generate') == 'yes'): ?>
    <div class="wc-billingo-plus-metabox-auto-msg <?php if(!$order->get_meta('_wc_billingo_plus_own') && !$has_invoice): ?>show<?php endif; ?>">
      <div class="wc-billingo-plus-metabox-auto-msg-text">
        <p><?php esc_html_e( 'A számla automatikusan elkészül, ha a rendelés állapota megváltozik erre:', 'wc-billingo-plus' ); ?> <strong><?php echo wc_get_order_status_name($this->get_option('auto_invoice_status', 'wc-completed')); ?></strong></p>
        <span class="dashicons dashicons-yes-alt"></span>
      </div>
    </div>
    <?php endif; ?>

    <div class="wc-billingo-plus-metabox-generate <?php if(!$order->get_meta('_wc_billingo_plus_own') && !$has_invoice): ?>show<?php endif; ?>">
      <ul class="wc-billingo-plus-metabox-generate-options" style="display:none">
        <li>
          <label><?php esc_html_e('Megjegyzés','wc-billingo-plus'); ?></label>
          <textarea id="wc_billingo_plus_invoice_note"><?php echo esc_textarea($this->get_option('note')); ?></textarea>
        </li>
        <li>
          <label><?php esc_html_e('Fizetési határidő(nap)','wc-billingo-plus'); ?></label>
          <input type="number" id="wc_billingo_plus_invoice_deadline" value="<?php echo absint($this->get_payment_method_deadline($order->get_payment_method())); ?>" />
        </li>
        <li>
          <label><?php esc_html_e('Teljesítés dátum','wc-billingo-plus'); ?></label>
          <input type="text" class="date-picker" id="wc_billingo_plus_invoice_completed" maxlength="10" value="<?php echo date('Y-m-d'); ?>" pattern="[0-9]{4}-(0[1-9]|1[012])-(0[1-9]|1[0-9]|2[0-9]|3[01])">
        </li>
        <li class="wc-billingo-plus-metabox-generate-options-type">
          <label><?php esc_html_e('Számla típusa','wc-billingo-plus'); ?></label>
          <label for="wc_billingo_plus_invoice_normal">
            <input type="radio" name="invoice_extra_type" id="wc_billingo_plus_invoice_normal" value="1" checked="checked" />
            <span><?php esc_html_e('Végszámla','wc-billingo-plus'); ?></span>
          </label>
          <label for="wc_billingo_plus_invoice_proform">
            <input type="radio" name="invoice_extra_type" id="wc_billingo_plus_invoice_proform" value="1" />
            <span><?php esc_html_e('Díjbekérő számla','wc-billingo-plus'); ?></span>
          </label>
        </li>
        <li>
          <a class="wc-billingo-plus-invoice-toggle off" href="#"><?php esc_html_e('Számlakészítés kikapcsolása','wc-billingo-plus'); ?></a>
        </li>
      </ul>
      <div class="wc-billingo-plus-metabox-generate-buttons">
        <a href="#" id="wc_billingo_plus_invoice_options"><?php esc_html_e('Opciók','wc-billingo-plus'); ?></a>
        <a href="#" id="wc_billingo_plus_invoice_generate" class="button button-primary" target="_blank" data-question="<?php esc_attr_e('Biztosan létrehozod a számlát?','wc-billingo-plus'); ?>">
          <?php esc_html_e('Számlakészítés','wc-billingo-plus'); ?>
        </a>
      </div>
    </div>
  </div>

<?php endif; ?>
